
Table table;
int numRows, numColumns;

float[][] dataMatrix;
float maxValue, minValue;

//rects
int horMargin = 160;
int verMargin = 40;
int topMargin = 10;
float cellWidth, cellHeight;

//Lablel
int startYear = 2006;
int endYear = 2014;

int circleRadius = 15;

boolean normalization = false;
boolean colorApplied = false;
String[] titles = {
"absolutely true diary of a part time indian",
"adventures of captain underpants",
"adventures of huckleberry finn",
"and tango makes three",
"athletic shorts",
"a bad boy can be good for a girl",
"bless me ultima",
"the bluest eye",
"bone volume 1: out from boneville",
"brave new world",
"catcher in the rye",
"the chocolate war",
"the color of earth",
"the color purple",
"crank",
"drama",
"the earth my butt and other big round things",
"fifty shades of grey",
"flashcards of my life",
"the glass castle",
"the golden compass",
"gossip girl",
"the hunger games",
"i know why the caged bird sings",
"its perfectly normal",
"the kite runner",
"looking for alaska",
"lush",
"my moms having a baby",
"my sisters keeper",
"nickel and dimed",
"olive's ocean",
"the perks of being a wallflower",
"persepolis",
"revolutionary voices",
"saga",
"scary stories",
"starting with alice",
"a stolen life",
"thirteen reasons why",
"to kill a mockingbird",
"ttyl",
"twilight",
"uncle bobby's wedding",
"what my mother doesnt know"};

void printDataMatrix(){
   for(int i=0; i<numColumns; i++){
    for(int j=0; j<numRows; j++){
      print(dataMatrix[i][j]);
      print(" ");
    }
    println();
   }
}

void setup(){
  size(1440, 800);
  surface.setResizable(true);

  //set the pixel density for retina display
  //int d = displayDensity();
  pixelDensity(2);
  
  //load the data from the csv
  table = loadTable("FrequentlyChallengedList.csv","header");
  numRows = table.getRowCount();
  numColumns = table.getColumnCount();
  
  dataMatrix = new float[numColumns][numRows];
  println("Rows: " + numRows + " Columns: " + numColumns);
  
  maxValue = 0;
  dataMatrix = new float[numColumns][numRows];
  for(int i=0; i<numColumns; i++){
    for(int j=0; j<numRows; j++){
      dataMatrix[i][j] = table.getFloat(j, i);
      if(dataMatrix[i][j] > maxValue){
        maxValue = dataMatrix[i][j];
      }
    }
  }
  
 // printDataMatrix();
  
  minValue = maxValue;
  for(int i=0; i<numColumns; i++){
    for(int j=0; j<numRows; j++){
      dataMatrix[i][j] = table.getFloat(j, i);
      if(dataMatrix[i][j] < minValue){
        minValue = dataMatrix[i][j];
      }
    }
  }
  
  println("Max Value: " + maxValue);
  println("Min Value: " + minValue);
  
  //print the available fonts
   //String[] fontList = PFont.list();
  //printArray(fontList);
}

void draw(){
  //background(#282D48);
  background(0);
  cellWidth = (width - 2*horMargin)/numRows;
  cellHeight = (height - 2*verMargin)/(numColumns) -10;
  
   //Drawing 2D Matrix on cavas
    for(int i=0; i<numColumns; i++){
      for(int j=0; j<numRows; j++){
        float brightness = map(dataMatrix[i][j], minValue, maxValue, 255, 0);
        fill(brightness);
        //hide the grid
        //rect( horMargin + cellWidth*j, topMargin + cellHeight*i ,cellWidth,cellHeight);
        ellipse(horMargin + cellWidth*j + cellWidth/2, topMargin + cellHeight*i + cellHeight / 2, circleRadius, circleRadius);
      }
    }
    
     //Add Vertical Labels
  PFont myFont = createFont("Helvetica-Light", 14);
  textFont(myFont);   
     
  for(int i=0; i<9; i++){
    fill(255);
    textAlign(RIGHT, CENTER);
    text(startYear+i, horMargin- 10, topMargin + cellHeight/2 + cellHeight*i);
  }
  
  //Add title labels
   PFont newFont = createFont("Helvetica-Light", 9);
   textFont(newFont); 
   textAlign(CENTER, CENTER);
  
  //Add text labels
  for(int i=0; i<titles.length; i++){
     pushMatrix();
     translate(horMargin + i * cellWidth + cellWidth/2, topMargin + cellHeight*(numColumns) + 10);
     rotate(-45);
     textAlign(RIGHT);
     text(titles[i],0 ,0 );
     popMatrix();
  }
  
  //Draw Title
  textAlign(RIGHT, CENTER);
  textSize(18);
  text("frequently", width - topMargin, verMargin/2);
  text("challenged", width - topMargin, verMargin/2 + 20);
  text("titles", width - topMargin, verMargin/2 + 40);
  text("2006 - 2014", width - topMargin, verMargin/2 + 60);
  
  //Add the legend
  textAlign(RIGHT, CENTER);
  textSize(14);
  text("checkout frequency", width - topMargin, height/2 );
  for (int i=0; i <13; i++){
    float brightness = map(((maxValue - minValue) / 13) * i, minValue, maxValue, 255, 0);
    fill(brightness);
    ellipse(width - topMargin - 120 + (10*i), height/2 + 20 , circleRadius - 8, circleRadius - 8);
  }
  
  if(normalization == true) normalization();
  else if(normalization == false) denormalize();
  
  if(colorApplied == true) colorScheme();
 
}